<?php
class DocConfig{
	public static $version = 1.1;
	public static function get($name){ return DocConfig::$data[$name]; }
	public static function set($name, $value){
		DocConfig::$data[$name]  = $value;
	}
	public static function has($name){ return array_key_exists($name, DocConfig::$data); }
	public static function preset($preset){
		$obj = DocConfig::$data;

		if ($preset !== false && array_key_exists($preset, $obj)){
			foreach ($obj[$preset] as $key => $value)
				DocConfig::set($key, $value);
		}
	}
	public static function read($config, $preset = false){
		DocConfig::set("root", "./");
		DocConfig::set("name", "madoka");
		DocConfig::set("plugins", __DIR__."/plugins/");
		DocConfig::set("temp", __DIR__."/temp/");
		DocConfig::set("templates", __DIR__."/templates/");
		DocConfig::set("export", __DIR__."/temp/export/");
		DocConfig::set("samples", "");
		DocConfig::set("singleItemToc", false);
		DocConfig::set("samples_http", "");
		DocConfig::set("api_usedby", false);
		DocConfig::set("api_signature", true);
		DocConfig::set("force_lowercase", true);
		
		if (is_file($config)){
			$data = file_get_contents($config);
			$obj = json_decode($data, true);
			foreach ($obj as $key => $value)
				DocConfig::set($key, $value);
		}

		DocConfig::preset($preset);

		if (DocConfig::get("minMadokaVersion") > DocConfig::$version){
			echo "Please update Madoka engine";
			die(1);
		}
	}
	public static $data = array();
}
DocConfig::$data["starttime"] = time();

class DocCache{
	private static $fileCache = array();
	private static $pageCache = array();
	public static function getFile($name){
		if (array_key_exists($name, DocCache::$fileCache))
			return DocCache::$fileCache[$name];

		return DocCache::$fileCache[$name] = file_get_contents($name);
	}
	public static function getTemplate($name){
		$folder = DocConfig::get("templates");
		$fullname = __DIR__."/templates/".$name;
		if (array_key_exists($fullname, DocCache::$fileCache))
			return DocCache::$fileCache[$fullname];

		if (is_file($folder.$name))
			return DocCache::$fileCache[$fullname] = file_get_contents($folder.$name);
		else
			return DocCache::$fileCache[$fullname] = file_get_contents($fullname);
	}
	public static function getPage($name){
		if (array_key_exists($name, DocCache::$pageCache))
			return DocCache::$pageCache[$name];
 
		return DocCache::$pageCache[$name] = new DocPage($name);
	}
}

?>